%define	desktop_vendor planetccrma
%define desktop_utils  %(test -x /usr/bin/desktop-file-install && echo "yes")

# do we build the keyboard interface to the ardour engine?
%define build_ksi 0

Summary:       Multichannel Digital Audio Workstation
Name:          ardour
Version:       0.9beta28
Release:       1
Source:        ardour-%{version}.tar.bz2
Source1:       ardour.png
Patch0:        ardour-0.9beta11.2-cerrno.patch
Patch1:        ardour-0.9beta20-templates.patch
URL:           http://ardour.sourceforge.net
Copyright:     GPL
Group:         Applications/Multimedia
Packager:      Fernando Lopez-Lezcano
BuildRoot:     %{_tmppath}/%{name}-%{version}-root
Vendor: Planet CCRMA
Distribution:  Planet CCRMA

BuildRequires: gcc-c++, libtool, pkgconfig, libtool, bison, byacc, flex 
BuildRequires: gtk+-devel, libart_lgpl-devel
BuildRequires: alsa-lib-devel, jack-audio-connection-kit-devel >= 0.97.3
BuildRequires: gettext >= 0.11.5
BuildRequires: libsndfile-devel >= 1.0.0
BuildRequires: libsamplerate-devel >= 0.0.13
BuildRequires: liblrdf-devel >= 0.3.1
BuildRequires: libxml2-devel >= 2.5.0

# uncomment if building a cvs version
# %if "%{cvsdate}" != "%{nil}"
# BuildRequires: autoconf >= 2.52
# %if "%{distro}" == "2" || "%{distro}" == "1"
# BuildRequires: automake >= 1.7
# %else
# BuildRequires: automake17
# %endif
# %endif

%description
Ardour is a multichannel hard disk recorder (HDR) and digital audio
workstation (DAW). It is capable of simultaneous recording 24 or more
channels of 32 bit audio at 48kHz. Ardour is intended to function as a
"professional" HDR system, replacing dedicated hardware solutions such
as the Mackie HDR, the Tascam 2424 and more traditional tape systems
like the Alesis ADAT series. It is also intended to provide the same
or better functionality as software systems such as ProTools,
Samplitude, Logic Audio, Nuendo and Cubase VST (we acknowledge these
and all other names as trademarks of their respective owners). It
supports MIDI Machine Control, and so can be controlled from any MMC
controller, such as the Mackie Digital 8 Bus mixer and many other
modern digital mixers.

%package ksi
Summary:       Curses-based interface to the Ardour library
Version:       %{version}
Group:         Applications/Multimedia

%description ksi
ardour/ksi is a curses-based interface to the Ardour engine that
allows you to use your ALSA-support audio interface as a powerful,
real-time multichannel mixer. ardour/ksi uses a key assignment
designed by Frank Carmickle that is incredibly ergonomic and easy to
use. It uses the keyboard to provide 10 channels worth of control at a
time, with other channels just a keypress away. ardour/ksi allows the
addition, editing and removal of LADPSA plugins to each channel, as
well as the usual mute/solo/pan/gain controls. 

In addition there is a utility called "remote_kbd". this
provides most of the functionality associated with X, but provides it
for programs like ardour/ksi that uses curses AND use the keyboard in
the kernel's "raw" mode. all existing TCP/IP-based remote protocols
(that I can think of) except X are based on transmitting characters
read from various inputs; in ardour/ksi we want to know about Ctrl-i
as distinct from TAB, for example. with the standard keyboard mode,
there is no way to distinguish between these two things. Since neither
telnet, nor rlogin nor ssh or the rest will transmit raw keycode
information in a useful way, remote_kbd provides a small program (250
lines in the source) that puts the keyboard in raw mode, transmits any
keycodes to a client connected via a socket, and forwards any data
read from the client to stdout.

This allows ardour/ksi to be run on a machine with, for example, a
low-latency kernel installed for high performance, but have the
display be on a machine with the SpeakUp system for screen readers.
If screen readers could handle X, this would not have been necessary.

%prep
%setup -q -n ardour-%{version}
%patch0 -p1
# %patch1 -p1

%build
%if "%{build_ksi}" == "1"
%configure --enable-optimize
%else
%configure --enable-optimize --disable-ksi
%endif
%{__make}

# ardour installs the static libardour library, we don't need it
%{__rm} -f %{buildroot}%{_libdir}/ardour/libardour*

%install
%{__rm} -rf %{buildroot}
%{__make} DESTDIR=%{buildroot} install

# install the icon
%{__mkdir} -p %{buildroot}/%{_datadir}/pixmaps/
%{__install} -m 644 %{SOURCE1} %{buildroot}/%{_datadir}/pixmaps/

# install the desktop entry
cat << EOF > %{desktop_vendor}-%{name}.desktop
[Desktop Entry]
Name=Ardour
Comment=Ardour Digital Audio Workstation
Icon=ardour.png
Exec=%{_bindir}/ardour
Terminal=false
Type=Application
EOF
%if "%{desktop_utils}" == "yes"
  %{__mkdir} -p %{buildroot}%{_datadir}/applications
  desktop-file-install --vendor %{desktop_vendor} \
    --dir %{buildroot}%{_datadir}/applications \
    --add-category X-Red-Hat-Base                 \
    --add-category AudioVideo                     \
    --add-category Application                    \
    %{desktop_vendor}-%{name}.desktop
%else
  %{__install} -d %{buildroot}%{_sysconfdir}/X11/applnk/Multimedia
  %{__install} %{desktop_vendor}-%{name}.desktop %{buildroot}%{_sysconfdir}/X11/applnk/Multimedia/
%endif

# rename the resulting binary in 7.3... sigh...
if [ -e "%{buildroot}%{_bindir}/i386-redhat-linux-ardour" ] ; then
  %{__mv} %{buildroot}%{_bindir}/i386-redhat-linux-ardour %{buildroot}%{_bindir}/ardour
fi

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-,root,root)
%doc README INSTALL COPYING DOCUMENTATION
%{_bindir}/ardour
%{_datadir}/ardour
%config /etc/ardour/*.rc
%{_mandir}/man1/ardour*
%{_mandir}/*/man1/ardour*
%{_datadir}/pixmaps/ardour*
%if "%{desktop_utils}" == "yes"
%{_datadir}/applications/*%{name}.desktop
%else
%{_sysconfdir}/X11/applnk/Multimedia/%{desktop_vendor}-%{name}.desktop
%endif
%{_datadir}/locale/*/*/*

%if "%{build_ksi}" == "1"
%files ksi
%defattr(-,root,root)
%{_bindir}/ksi
%{_bindir}/remote_kbd
%endif

%changelog
* Wed Mar  9 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta28-1
- updated to 0.9beta28
* Sat Feb 25 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta27-1
- updated to 0.9beta27
* Thu Feb 10 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta26-1
- updated to 0.9beta26
* Tue Feb  8 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta25-1
- updated to 0.9beta25
* Fri Jan 21 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta24-1
- updated to 0.9beta24
* Thu Jan  6 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta23-1
- updated to 0.9beta23
* Sun Dec 19 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta22-1
- updated to 0.9beta22, spec file cleanup
- fixed icon (file was xpm, menu said png)
* Mon Nov  1 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta21-1
- updated to 0.9beta21... in the same day! :-)
- added automake and autoconf build requirements only when build
* Mon Nov  1 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta20-1
- updated to 0.9beta20
- add automake >= 1.7 build requirement
- added templates patch, thank to Torbjrn Turpeinen (Thac)
* Fri Aug  6 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta19
- updated to 0.9beta19
* Sun Jul 25 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta18.4-1
- updated to 0.9beta18.4
* Fri Jul 23 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta18.3-1
- updated to 0.9beta18.3, added Jeese Chappell tempotype patch
* Tue Jul 20 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta18.2-1
- updated to 0.9beta18.2
* Sat Jul 17 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta18.1-1
- updated to 0.9beta18.1
* Sun Jul  4 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta17.1-1
- updated to 0.9beta17.1
* Mon Jun  7 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta16.1-1
- updated to 0.9beta16.1
* Mon May 24 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta14.3-1
- updated to 0.9beta14.3
- added patch for translated man install, added to file list as well
* Mon May 10 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- updated buildrequires list
- added proper documentation files
* Sun Feb 29 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta11.2-1
- updated to 0.9beta11.2
* Mon Feb 16 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta10.2-1
- updated to 0.9beta10.2
* Thu Jan 15 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta9-2
- this is the "real" beta9, the previous release was an interim tarball
  that I should not have released (but I did because of some important
  bug fixes that it incorporated). 
- added patch for building with gcc296
* Tue Dec  2 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta9-1
- updated to 0.9beta9
- added explicit dependency to jack >= 0.91.1
- patched region.h to build under gcc <3
* Sat Nov  8 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta8-1
- added release tags, spec file tweaks
* Tue Oct 28 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta8-1
- updated to 0.9beta8
* Mon Oct 27 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta7-1
- updated to 0.9beta7
- 7.3 names the binary with the i386 prefix, hack around the problem
* Fri Oct 10 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta5
- updated to 0.9beta5
- add patch to build under gcc 2.96 (Patch0)
* Thu Aug 14 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta3
- updated to 0.9beta3
- added release tags
 * Wed Jul  2 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.9beta2
- first public release
* Tue Jun 17 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.0beta1
- redid spec file completely for tarball release
* Fri May 30 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.360-1
- readded libtool fix for 7.2/7.3
* Wed May  7 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.345-1
- added workaround for missing version.h file in gtk_ardour
* Wed Mar 19 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu>
- changed over to pixmaps 2.6
* Sun Feb  3 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu>
- added locale files
* Sun Jan 19 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu>
- major upgrade to spec file, getting ready for release
- split package into ardour and libardour, add ardour-ksi
- added some build dependecies
- does not need the special startup script, finds defaults
- borrowed icon from mandrake source rpm by Torbjrn Turpeinen
- added menu entry
* Wed Dec 11 2002 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.305.0-1
- update to cvs
* Fri Dec  6 2002 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.303.1-1
- added gettext dependency
* Wed Aug 21 2002 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.239.1-1
- update to cvs
* Tue Jul 16 2002 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.229.1-1
- update to cvs
* Wed Apr 24 2002 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.220.1-1
- update to cvs
* Thu Apr 11 2002 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.220.0-1
- update to latest cvs
* Fri Mar 15 2002 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.213.0-1
- updated to latest cvs, added rtcap patch
* Thu Mar 14 2002 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.211.0-1
- updated to the latest cvs
- require autoconf >= 2.52 to build
- disable ksi build till it is jackified
* Thu Jul 12 2001 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu>
- updated to latest cvs
- things to do after it is installed:
    setenv ARDOURRC /etc/ardourrc.scm
    edit /etc/ardourrc.scm:
(set-config-var ui-rcfile "/usr/lib/ardour/ardour_ui.rc")
(set-config-var pixmap-path "/usr/lib/ardour/pixmaps")
    edit /usr/lib/ardour/ardour_rc.ui
pixmap_path "./pixmaps:/usr/lib/ardour/pixmaps"
    ardour -d hw -p /usr/lib/aes
    ardour -d hw -p /usr/lib/aes -s 44100 -f 256 -R
* Tue Apr 10 2001 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu>
- installed "by hand"
- created startup script
* Mon Apr  9 2001 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu>
- spec file created
- created ardour-get-cvs to autodownload all code and libraries:
  cd ../SOURCES; ./ardour-get-cvs, follow prompts
- fixed problem with incompatible exceptions for "exit"
- fixed problem with undefined @LIBTOOL@ in make install
- store ardour and all related files in /usr/lib/ardour, start ardour
  with a bash script that sets the proper env variable to point to a
  configuration file in /etc, point all configuration paths to 
  /usr/lib/ardour/

